/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package es.uca.takuan.netbeans.components;

import java.io.FileWriter;
import java.io.IOException;
import java.io.Serializable;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import org.openide.util.Exceptions;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;

/**
 * Top component which displays something.
 */
final public class TakuanOutputTopComponent extends TopComponent {

    private static TakuanOutputTopComponent instance;
    private static final String PREFERRED_ID = "TakuanOutputTopComponent";
    static final String ICON_PATH = "es/uca/takuan/netbeans/icon16x16.png";

    private TakuanOutputTopComponent() {
        initComponents();
        setName(NbBundle.getMessage(TakuanOutputTopComponent.class, "CTL_TakuanOutputTopComponent"));
        setToolTipText(NbBundle.getMessage(TakuanOutputTopComponent.class, "HINT_TakuanOutputTopComponent"));
        setIcon(Utilities.loadImage(ICON_PATH, true));
    }
    
    /** This method is used to clear the output
     */
    public void clear() {
        txtOutput.setText("");
    }

    /** Print the string
     * @param str The string to be printed
     */
    public void print(String str) {
        txtOutput.append(str);
        txtOutput.setCaretPosition(txtOutput.getDocument().getLength());
    }
    
    /** This method is used to add new lines
     * @param str The string to be printed
     */
    public void println(String str) {
        txtOutput.append(str + "\n");
        txtOutput.setCaretPosition(txtOutput.getDocument().getLength());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        txtOutput = new javax.swing.JTextArea();
        cmdClear = new javax.swing.JButton();
        cmdSave = new javax.swing.JButton();

        setForeground(java.awt.Color.white);

        txtOutput.setColumns(20);
        txtOutput.setEditable(false);
        txtOutput.setForeground(new java.awt.Color(153, 0, 0));
        txtOutput.setRows(5);
        jScrollPane1.setViewportView(txtOutput);

        org.openide.awt.Mnemonics.setLocalizedText(cmdClear, org.openide.util.NbBundle.getMessage(TakuanOutputTopComponent.class, "CLEAR")); // NOI18N
        cmdClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdClearActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(cmdSave, org.openide.util.NbBundle.getMessage(TakuanOutputTopComponent.class, "SAVE")); // NOI18N
        cmdSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 512, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(344, 344, 344)
                .add(cmdSave)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(cmdClear))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 270, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cmdClear)
                    .add(cmdSave)))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void cmdClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdClearActionPerformed
        clear();
    }//GEN-LAST:event_cmdClearActionPerformed

    private void saveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveActionPerformed
        JFileChooser saveDialog = new JFileChooser();
        
        saveDialog.setMultiSelectionEnabled(false);
        
        if(saveDialog.showSaveDialog(this) == JFileChooser.APPROVE_OPTION)
        {
            try {
                FileWriter output = null;
                output = new FileWriter(saveDialog.getSelectedFile());
                txtOutput.write(output);
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }//GEN-LAST:event_saveActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cmdClear;
    private javax.swing.JButton cmdSave;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea txtOutput;
    // End of variables declaration//GEN-END:variables
    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link findInstance}.
     */
    public static synchronized TakuanOutputTopComponent getDefault() {
        if (instance == null) {
            instance = new TakuanOutputTopComponent();
        }
        return instance;
    }

    /**
     * Obtain the TakuanOutputTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized TakuanOutputTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(TakuanOutputTopComponent.class.getName()).warning(
                    "Cannot find " + PREFERRED_ID + " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof TakuanOutputTopComponent) {
            return (TakuanOutputTopComponent) win;
        }
        Logger.getLogger(TakuanOutputTopComponent.class.getName()).warning(
                "There seem to be multiple components with the '" + PREFERRED_ID +
                "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_ALWAYS;
    }

    @Override
    public void componentOpened() {
    // TODO add custom code on component opening
    }

    @Override
    public void componentClosed() {
    // TODO add custom code on component closing
    }

    /** replaces this in object stream */
    @Override
    public Object writeReplace() {
        return new ResolvableHelper();
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }

    static final class ResolvableHelper implements Serializable {

        private static final long serialVersionUID = 1L;

        public Object readResolve() {
            return TakuanOutputTopComponent.getDefault();
        }
    }
}
